/* generated using openapi-typescript-codegen -- do not edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { ApiTokenIn } from '../models/ApiTokenIn';
import type { ApiTokenOut } from '../models/ApiTokenOut';
import type { ApiTokenPrivateOut } from '../models/ApiTokenPrivateOut';
import type { CancelablePromise } from '../core/CancelablePromise';
import { OpenAPI } from '../core/OpenAPI';
import { request as __request } from '../core/request';
export class ApiTokenService {
    /**
     * List API token
     * List meta information about all API token.
     *
     * Permissions `api_token:list_all` required. See parameter `uid` for exception.
     * @param uid UID of the user to filter for. Permission `api_token:list` required if current users is the target.
     * @returns ApiTokenOut Successful Response
     * @throws ApiError
     */
    public static apiTokenListToken(
        uid?: string,
    ): CancelablePromise<Array<ApiTokenOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/tokens',
            query: {
                'uid': uid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Create new API token
     * Create a new API token for the current user.
     *
     * Permission `api_token:create` required.
     * @param requestBody
     * @returns ApiTokenPrivateOut Successful Response
     * @throws ApiError
     */
    public static apiTokenCreateToken(
        requestBody: ApiTokenIn,
    ): CancelablePromise<ApiTokenPrivateOut> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/tokens',
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Get API token
     * Get an API token by id.
     *
     * Permission `api_token:read` required if the current user is the owner of the API token,
     * otherwise `api_token:read_any` required.
     * @param tid ID of an API token
     * @returns ApiTokenOut Successful Response
     * @throws ApiError
     */
    public static apiTokenGetToken(
        tid: string,
    ): CancelablePromise<ApiTokenOut> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/tokens/{tid}',
            path: {
                'tid': tid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Delete API token
     * Delete an API token by id.
     *
     * Permission `api_token:delete` required if the current user is the owner of the API token,
     * otherwise `api_token:delete_any` required.
     * @param tid ID of an API token
     * @returns void
     * @throws ApiError
     */
    public static apiTokenDeleteToken(
        tid: string,
    ): CancelablePromise<void> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/tokens/{tid}',
            path: {
                'tid': tid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
}
